## pushover 0.0.5+git20180420

=== Makefile ===
CXXFLAGS := -Wall -g -O2

PREFIX := /usr
BINDIR := $(PREFIX)/bin
DATADIR := $(PREFIX)/share
DESTDIR :=

CROSS :=
CXX := $(CROSS)g++
INSTALL := install
MSGFMT := msgfmt
MSGMERGE := msgmerge
PKG_CONFIG := $(CROSS)pkg-config
POVRAY := povray
XGETTEXT := xgettext

MSGID_BUGS_ADDRESS := roever@users.sf.net

FILES_H := $(wildcard src/*.h src/linebreak/*.h)
FILES_CPP := $(wildcard src/*.cpp src/linebreak/*.c)
FILES_O := $(patsubst src/%,build_tmp/o/%.o,$(FILES_CPP))
FILES_PO := $(wildcard po/*.po)
FILES_MO := $(patsubst po/%.po,pushover_data/locale/%/LC_MESSAGES/pushover.mo,$(FILES_PO))
FILES_DATA_SRC := $(wildcard data/*.ogg data/*.png)
FILES_DATA := $(patsubst data/%,pushover_data/pushover/data/%,$(FILES_DATA_SRC))
FILES_THEMES_SRC := $(wildcard themes/*)
FILES_THEMES := $(patsubst themes/%,pushover_data/pushover/themes/%,$(FILES_THEMES_SRC))
FILES_LEVELS_SRC := $(wildcard levels/*/*)
FILES_LEVELS_SRCDIRS := $(wildcard levels/*)
FILES_LEVELS := $(patsubst levels/%,pushover_data/pushover/levels/%.gz,$(FILES_LEVELS_SRCDIRS))
FILES_GENERATED_SRC := generated/dominos.png
FILES_GENERATED := pushover_data/pushover/data/dominos.png
FILES_EXTRA := AUTHORS COPYING Makefile NEWS pushover.ico README
FILES_DATADIR := $(FILES_MO) $(FILES_DATA) $(FILES_THEMES) $(FILES_LEVELS) $(FILES_GENERATED)
FILES_DATADIR_INSTALL := $(patsubst pushover_data/%,$(DESTDIR)$(DATADIR)/%,$(FILES_DATADIR))
FILES_BINDIR_INSTALL := $(DESTDIR)$(BINDIR)/pushover
FILES_DIST := src/version $(FILES_EXTRA) $(FILES_H) $(FILES_CPP) $(FILES_PO) $(FILES_DATA_SRC) $(FILES_THEMES_SRC) $(FILES_LEVELS_SRC) $(FILES_GENERATED_SRC)
VERSION := $(shell cat src/version)
PKG_LUA := $(shell pkg-config --exists lua-5.2 && echo lua-5.2 || echo lua)

DIST := pushover-$(VERSION).tgz

DEF_VERSION := -DVERSION='"$(VERSION)"'
DEF_DATADIR := -DDATADIR='"$(DATADIR)"'

PKGS += $(PKG_LUA)
PKGS += SDL_mixer
PKGS += SDL_ttf
PKGS += fribidi
PKGS += libpng
PKGS += sdl
PKGS += zlib

LIBS += -lboost_filesystem
LIBS += -lboost_system

PKGS_ASSEMBLER += SDL_image
PKGS_ASSEMBLER += libpng
PKGS_ASSEMBLER += sdl

.DELETE_ON_ERROR:

.PHONY: default
default: pushover $(FILES_DATADIR)

.PHONY: dist
dist: $(DIST)

.PHONY: check
check: pushover $(FILES_DATADIR)
	./pushover -c recordings/finish/*
	./pushover -y recordings/fail
	./pushover -x recordings/crash
	@echo OK

.PHONY: install
install: $(FILES_BINDIR_INSTALL) $(FILES_DATADIR_INSTALL)

.PHONY: clean
clean:
	rm -f pushover
	rm -f $(DIST)
	rm -rf build_tmp/
	rm -rf pushover_data/
	@echo Not removing generated/

.PHONY: update-po
update-po: build_tmp/po/messages.pot
	for PO_FILE in po/*.po; do $(MSGMERGE) -Uq --backup=none $$PO_FILE $<; done

.SECONDARY: $(FILES_O)
build_tmp/o/%.o: src/% src/version $(FILES_H)
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) `$(PKG_CONFIG) --cflags $(PKGS)` $(DEF_VERSION) $(DEF_DATADIR) -c -o $@ $<

pushover: $(FILES_O)
	$(CXX) $(CXXFLAGS) `$(PKG_CONFIG) --libs $(PKGS)` $(LIBS) -o $@ $(FILES_O)

.SECONDARY: build_tmp/assembler
build_tmp/assembler: data/sources/assembler.cpp data/sources/pngsaver.h
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) `$(PKG_CONFIG) --cflags $(PKGS_ASSEMBLER)` `$(PKG_CONFIG) --libs $(PKGS_ASSEMBLER)` -o $@ $<

.SECONDARY: build_tmp/domino_images/done
build_tmp/domino_images/done: data/sources/domino.ini data/sources/*.pov
	mkdir -p $(dir $@)
	$(POVRAY) $<
	touch $@

generated/dominos.png: build_tmp/assembler build_tmp/domino_images/done
	mkdir -p $(dir $@)
	build_tmp/assembler $@ 58 2 200 data/sources/dominos.lst

pushover_data/locale/%/LC_MESSAGES/pushover.mo: po/%.po
	mkdir -p $(dir $@)
	$(MSGFMT) -c -o $@ $<

pushover_data/pushover/data/%: data/%
	mkdir -p $(dir $@)
	cp $< $@

pushover_data/pushover/data/dominos.png: generated/dominos.png
	mkdir -p $(dir $@)
	cp $< $@

pushover_data/pushover/themes/%: themes/%
	mkdir -p $(dir $@)
	cp $< $@

pushover_data/pushover/levels/%.gz: levels/%/*.level
	mkdir -p $(dir $@)
	cat levels/$*/*.level | gzip -9 >$@

build_tmp/po/leveltexts.cpp: levels/*/*.level
	mkdir -p $(dir $@)
	sed -n '/^\(Description\|Hint\|Name\|Tutorial\)$$/,/^[^|]/ s,^| \(.*\)$$,_("\1"),p' $^ | LC_ALL=C sort -u >$@

build_tmp/po/messages.pot: build_tmp/po/leveltexts.cpp src/*.cpp
	mkdir -p $(dir $@)
	$(XGETTEXT) --msgid-bugs-address=$(MSGID_BUGS_ADDRESS) -cTRANSLATORS: -k_ -kN_ -o $@ $^

$(DESTDIR)$(BINDIR)/%: %
	$(INSTALL) -m 755 -d $(dir $@)
	$(INSTALL) -m 755 $< $@

$(DESTDIR)$(DATADIR)/%: pushover_data/%
	$(INSTALL) -m 755 -d $(dir $@)
	$(INSTALL) -m 644 $< $@

$(DIST): $(FILES_DIST)
	rm -rf build_tmp/$(basename $@)
	mkdir -p build_tmp/$(basename $@)
	tar c $^ | tar x -C build_tmp/$(basename $@)
	tar c -C build_tmp $(basename $@) | gzip -9n >$@

=== debian/changelog ===
pushover (0.0.5+git20180420-2ubuntu1) cosmic; urgency=medium

  * debian/patches/library-link-order.patch: Ensure libraries linked are
    listed after objects using them.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 22 Aug 2018 16:12:10 -0700

pushover (0.0.5+git20180420-2) unstable; urgency=medium

  * debian/pushover.6: updated. (Closes: #896984)
  * Added to Debian Games Team.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 02 May 2018 15:08:23 +0200

pushover (0.0.5+git20180420-1) unstable; urgency=medium

  * Initial release. (Closes: #505966)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 20 Apr 2018 12:23:21 +0200

=== debian/control ===
Source: pushover
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), liblua5.3-dev, libsdl-mixer1.2-dev, libsdl-ttf2.0-dev, libfribidi-dev, povray, libboost-dev, libsdl-image1.2-dev, libboost-filesystem-dev, libboost-system-dev
Standards-Version: 4.1.3
Homepage: https://pushover.github.io/

Package: pushover
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fun puzzle game with dominos
 This is a fun puzzle game originally published by Ocean in 1992. In this
 game you control an ant that can walk along platformt that are connected
 with ladders. On those platforms are dominos that need to fall according
 to some rules.
 .
  - All dominos must fall and none must crash into another
  - One special domino must fall as last domino and that domino triggers
    the exit door to open when you enter the exit door the level has been
    completed
  - You may rearrange as many dominos as you want, except for the trigger.
    You may not place dominos in front of the doors, except for the vanishing
    domino.
  - You may push once to start a chain reaction with the dominos leading to
    the fall of all of them
  - All this has to be done within a time limit (which is normally generous)
  - There are 10 different dominos that behave differently when pushed, some
    fall, some not, some wait a bit before they fall, some raise, some toppler
    until they meet an obstacle
  - There is a help in the game and introductory levels that show how all the
    dominos work

## pushover 0.0.5+git20180909

=== Makefile ===
PREFIX ?= /usr
BINDIR ?= $(PREFIX)/bin
DATADIR ?= $(PREFIX)/share
DESTDIR ?=
CROSS ?=

CONVERT ?= convert
CXX ?= $(CROSS)g++
CXXFLAGS ?= -Wall -Wextra -g -O2
INSTALL ?= install
LDFLAGS ?=
MSGFMT ?= msgfmt
MSGMERGE ?= msgmerge
PKG_CONFIG ?= $(CROSS)pkg-config
POVRAY ?= povray
XGETTEXT ?= xgettext

PKG_LUA_DEFAULT := $(shell $(PKG_CONFIG) --exists lua-5.2 && echo lua-5.2 || echo lua)
PKG_LUA ?= $(PKG_LUA_DEFAULT)

MSGID_BUGS_ADDRESS := roever@users.sf.net

.DELETE_ON_ERROR:

.PHONY: default
default: all

VERSION := $(shell cat src/version)
FILES_DIST += src/version

PKGS += $(PKG_LUA)
PKGS += SDL_mixer
PKGS += SDL_ttf
PKGS += fribidi
PKGS += libpng
PKGS += sdl
PKGS += zlib

LIBS += -lboost_filesystem
LIBS += -lboost_system

DEFS += -DVERSION='"$(VERSION)"'
DEFS += -DDATADIR='"$(DATADIR)"'

FILES_H := $(wildcard src/pushover/*.h src/pushover/linebreak/*.h src/pushover/sha1/*.hpp)
FILES_DIST += $(FILES_H)
FILES_CPP := $(wildcard src/pushover/*.cpp src/pushover/linebreak/*.c src/pushover/sha1/*.cpp)
FILES_DIST += $(FILES_CPP)
FILES_O := $(patsubst src/pushover/%,_tmp/pushover/%.o,$(FILES_CPP))

.SECONDARY: $(FILES_O)
_tmp/pushover/%.o: src/pushover/% src/version $(FILES_H)
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) `$(PKG_CONFIG) --cflags $(PKGS)` $(DEFS) -c -o $@ $<

FILES_BINDIR += pushover

pushover: $(FILES_O)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $(FILES_O) `$(PKG_CONFIG) --libs $(PKGS)` $(LIBS)

ASSEMBLER_PKGS += SDL_image
ASSEMBLER_PKGS += libpng
ASSEMBLER_PKGS += sdl

ASSEMBLER_SOURCES := src/dominoes/assembler.cpp src/dominoes/pngsaver.h
FILES_DIST += $(ASSEMBLER_SOURCES)

.SECONDARY: _tmp/dominoes/assembler
_tmp/dominoes/assembler: $(ASSEMBLER_SOURCES)
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) `$(PKG_CONFIG) --cflags $(ASSEMBLER_PKGS)` -o $@ $< `$(PKG_CONFIG) --libs $(ASSEMBLER_PKGS)`

DOMINOES_SOURCES := src/dominoes/domino.ini $(wildcard src/dominoes/*.pov)
FILES_DIST += $(DOMINOES_SOURCES)

.SECONDARY: _tmp/dominoes/done
_tmp/dominoes/done: $(DOMINOES_SOURCES)
	mkdir -p $(dir $@)
	$(POVRAY) $<
	touch $@

FILES_DIST += generated/dominoes.png

generated/dominoes.png: _tmp/dominoes/assembler _tmp/dominoes/done
	mkdir -p $(dir $@)
	_tmp/dominoes/assembler $@ 58 2 200 src/dominoes/dominoes.lst

FILES_DATADIR += data/pushover/images/dominoes.png

data/pushover/images/dominoes.png: generated/dominoes.png
	mkdir -p $(dir $@)
	cp $< $@

FILES_IMAGES_SRC := $(wildcard src/images/*.png)
FILES_DIST += $(FILES_IMAGES_SRC)
FILES_DATADIR += $(patsubst src/images/%,data/pushover/images/%,$(FILES_IMAGES_SRC))

data/pushover/images/%: src/images/%
	mkdir -p $(dir $@)
	cp $< $@

FILES_SOUNDS_SRC := $(wildcard src/sounds/*.ogg)
FILES_DIST += $(FILES_SOUNDS_SRC)
FILES_DATADIR += $(patsubst src/sounds/%,data/pushover/sounds/%,$(FILES_SOUNDS_SRC))

data/pushover/sounds/%: src/sounds/%
	mkdir -p $(dir $@)
	cp $< $@

FILES_THEMES_SRC := $(wildcard src/themes/*)
FILES_DIST += $(FILES_THEMES_SRC)
FILES_DATADIR += $(patsubst src/themes/%,data/pushover/themes/%,$(FILES_THEMES_SRC))

data/pushover/themes/%: src/themes/%
	mkdir -p $(dir $@)
	cp $< $@

FILES_PO := $(wildcard src/po/*.po)
FILES_DIST += $(FILES_PO)
FILES_DATADIR += $(patsubst src/po/%.po,data/locale/%/LC_MESSAGES/pushover.mo,$(FILES_PO))

data/locale/%/LC_MESSAGES/pushover.mo: src/po/%.po
	mkdir -p $(dir $@)
	$(MSGFMT) -c -o $@ $<

FILES_DIST += src/description/pushover.appdata.xml
FILES_DATADIR += data/metainfo/pushover.appdata.xml

data/metainfo/pushover.appdata.xml: src/description/pushover.appdata.xml
	mkdir -p $(dir $@)
	cp $< $@

FILES_DIST += src/description/pushover.desktop
FILES_DATADIR += data/applications/pushover.desktop

data/applications/pushover.desktop: src/description/pushover.desktop
	mkdir -p $(dir $@)
	cp $< $@

FILES_DIST += src/description/pushover.ico
FILES_PNG_ICON += generated/pushover_16x16.png
FILES_PNG_ICON += generated/pushover_32x32.png
FILES_PNG_ICON += generated/pushover_48x48.png
FILES_PNG_ICON += generated/pushover_64x64.png
FILES_DIST += $(FILES_PNG_ICON)

generated/pushover_%.png: src/description/pushover.ico
	mkdir -p $(dir $@)
	$(CONVERT) $<[$(shell expr substr $* 1 2 / 16 - 1)] $@

FILES_DATADIR += $(patsubst generated/pushover_%.png,data/icons/hicolor/%/apps/pushover.png,$(FILES_PNG_ICON))

data/icons/hicolor/%/apps/pushover.png: generated/pushover_%.png
	mkdir -p $(dir $@)
	cp $< $@

FILES_DIST += src/description/pushover.6
FILES_DATADIR += data/man/man6/pushover.6.gz

data/man/man6/pushover.6.gz: src/description/pushover.6
	mkdir -p $(dir $@)
	gzip -9n <$< >$@

FILES_DIST += $(wildcard src/levels/*/*)
FILES_LEVELS_SRCDIRS := $(wildcard src/levels/*)
FILES_DATADIR += $(patsubst src/levels/%,data/pushover/levels/%.gz,$(FILES_LEVELS_SRCDIRS))

data/pushover/levels/%.gz: src/levels/%/*.level
	mkdir -p $(dir $@)
	cat src/levels/$*/*.level | gzip -9n >$@

_tmp/po/leveltexts.cpp: src/levels/*/*.level
	mkdir -p $(dir $@)
	sed -n '/^\(Description\|Hint\|Name\|Tutorial\)$$/,/^[^|]/ s,^| \(.*\)$$,_("\1"),p' src/levels/*/*.level | LC_ALL=C sort -u >$@

.PHONY: all
all: $(FILES_BINDIR) $(FILES_DATADIR)

FILES_DIST += $(wildcard src/recordings/*/*.rec src/recordings/finish/*/*.rec)

.PHONY: check
check: all
	./pushover -c src/recordings/finish/*
	./pushover -y src/recordings/fail
	./pushover -x src/recordings/crash
	@echo OK

DIST := pushover-$(VERSION).tgz

.PHONY: dist
dist: $(DIST)

FILES_DIST += AUTHORS
FILES_DIST += LICENSE
FILES_DIST += Makefile
FILES_DIST += NEWS
FILES_DIST += README

$(DIST): $(FILES_DIST)
	rm -rf _tmp/$(basename $@)
	mkdir -p _tmp/$(basename $@)
	tar c $^ | tar x -C _tmp/$(basename $@)
	tar c --owner=0 --group=0 --numeric-owner --mtime='1970-01-01T00:00:00Z' -C _tmp $(basename $@) | gzip -9n >$@
	rm -rf _tmp/$(basename $@)
	tar x -f $@ -C _tmp
	$(MAKE) -C _tmp/$(basename $@) all -j 8 CONVERT='exit 1;' POVRAY='exit 1;'
	$(MAKE) -C _tmp/$(basename $@) check
	$(MAKE) -C _tmp/$(basename $@) install DESTDIR=`pwd`/_tmp/$(basename $@)/_test_destdir
	rm -rf _tmp/$(basename $@)

FILES_INSTALL += $(patsubst %,$(DESTDIR)$(BINDIR)/%,$(FILES_BINDIR))

$(DESTDIR)$(BINDIR)/%: %
	$(INSTALL) -m 755 -d $(dir $@)
	$(INSTALL) -m 755 $< $@

FILES_INSTALL += $(patsubst data/%,$(DESTDIR)$(DATADIR)/%,$(FILES_DATADIR))

$(DESTDIR)$(DATADIR)/%: data/%
	$(INSTALL) -m 755 -d $(dir $@)
	$(INSTALL) -m 644 $< $@

.PHONY: install
install: $(FILES_INSTALL)

.PHONY: clean
clean:
	rm -f $(DIST) $(FILES_BINDIR) $(FILES_DEBUG)
	rm -rf _tmp/ data/
	@echo Not removing generated/

.PHONY: update-po
update-po: _tmp/po/messages.pot
	for PO_FILE in src/po/*.po; do $(MSGMERGE) -Uq --backup=none $$PO_FILE $<; done

_tmp/po/messages.pot: _tmp/po/leveltexts.cpp src/pushover/*.cpp
	mkdir -p $(dir $@)
	$(XGETTEXT) --msgid-bugs-address=$(MSGID_BUGS_ADDRESS) -cTRANSLATORS: -k_ -kN_ -o $@ $^

=== debian/changelog ===
pushover (0.0.5+git20180909-4build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Feb 2020 11:07:00 +0000

pushover (0.0.5+git20180909-4) unstable; urgency=medium

  * Bump standards version to 4.4.1.
  * Add Vcs fields.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 14 Nov 2019 13:27:08 +0100

pushover (0.0.5+git20180909-3) unstable; urgency=medium

  * Add missing Breaks+Replaces. (Closes: #908675)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 12 Sep 2018 16:28:17 +0200

pushover (0.0.5+git20180909-2) unstable; urgency=medium

  * Add missing Depends fonts-freefont-ttf. (Closes: #908517)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 11 Sep 2018 16:58:43 +0200

pushover (0.0.5+git20180909-1) unstable; urgency=medium

  * New upstream version. (Closes: #897905, #906998)
  * Bump standards version to 4.2.1.
  * debian/control: fix typo in long description.
  * debian/pushover.desktop: dropped, included upstream.
  * Put music into a new package, pushover-data.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 09 Sep 2018 13:55:07 +0200

=== debian/rules ===
#!/usr/bin/make -f
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	rm -rf $(CURDIR)/debian/pushover/usr/bin/pushover
	rm -rf $(CURDIR)/debian/pushover/usr/bin

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/pushover/pushover.github.io/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## pushover 1.1

=== Makefile ===
# Domino-Chain
#
# Domino-Chain is the legal property of its developers, whose
# names are listed in the AUTHORS file, which is included
# within the source distribution.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1335 USA

PREFIX = /usr
BINDIR = $(PREFIX)/bin
DATADIR = $(PREFIX)/share
DESTDIR =
CROSS =

BOOST_TAGS := $(if $(filter %-w64-mingw32.static-,$(CROSS)),-mt,)
CONVERT = convert
CXX = $(CROSS)$(CXX_NATIVE)
CXX_NATIVE = g++
CXXFLAGS = -Wall -Wextra -g -O2 -std=c++17
EXEEXT = $(if $(filter %-w64-mingw32.static-,$(CROSS)),.exe,)
INSTALL = install
LDFLAGS =
MSGFMT = msgfmt
MSGMERGE = msgmerge
PKG_CONFIG = $(CROSS)$(PKG_CONFIG_NATIVE)
PKG_CONFIG_NATIVE = pkg-config
PKG_LUA := $(shell $(PKG_CONFIG) --exists lua-5.2 && echo lua-5.2 || echo lua)
POVRAY = povray
XGETTEXT = xgettext

MSGID_BUGS_ADDRESS := roever@users.sf.net

.DELETE_ON_ERROR:

.PHONY: default
default: all

VERSION := $(shell cat src/version)
ALL_SOURCES := $(wildcard src/* src/*/* src/*/*/* src/*/*/*/*)

PKGS += $(PKG_LUA)
PKGS += SDL2_mixer
PKGS += SDL2_ttf
PKGS += fribidi
PKGS += libpng
PKGS += sdl2
PKGS += zlib

LIBS += -lboost_filesystem$(BOOST_TAGS)
LIBS += -lboost_system$(BOOST_TAGS)

DEFS += -DVERSION='"$(VERSION)"'
DEFS += -DDATADIR='"$(DATADIR)"'

FILES_H := $(wildcard src/domino-chain/*.h src/domino-chain/linebreak/*.h src/domino-chain/sha1/*.hpp)
FILES_CPP := $(wildcard src/domino-chain/*.cpp src/domino-chain/linebreak/*.c src/domino-chain/sha1/*.cpp)
FILES_O := $(patsubst src/domino-chain/%,_tmp/$(CROSS)domino-chain/%.o,$(FILES_CPP))
.SECONDARY: $(FILES_O)
_tmp/$(CROSS)domino-chain/%.o: src/domino-chain/% src/version $(FILES_H)
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $$($(PKG_CONFIG) --cflags $(PKGS)) $(DEFS) -c -o $@ $<

FILES_BINDIR += $(CROSS)domino-chain$(EXEEXT)
$(CROSS)domino-chain$(EXEEXT): $(FILES_O)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $(FILES_O) $$($(PKG_CONFIG) --libs $(PKGS)) $(LIBS)

ASSEMBLER_PKGS += SDL2_image
ASSEMBLER_PKGS += libpng
ASSEMBLER_PKGS += sdl2

ASSEMBLER_SOURCES := src/dominoes/assembler.cpp src/dominoes/pngsaver.h
.SECONDARY: _tmp/dominoes/assembler
_tmp/dominoes/assembler: $(ASSEMBLER_SOURCES)
	@mkdir -p $(dir $@)
	$(CXX_NATIVE) $(CXXFLAGS) $(LDFLAGS) $$($(PKG_CONFIG_NATIVE) --cflags $(ASSEMBLER_PKGS)) -o $@ $< $$($(PKG_CONFIG_NATIVE) --libs $(ASSEMBLER_PKGS))

DOMINOES_SOURCES := src/dominoes/domino.ini $(wildcard src/dominoes/*.pov)
.SECONDARY: _tmp/dominoes/povray_done
_tmp/dominoes/povray_done: $(DOMINOES_SOURCES)
	@mkdir -p $(dir $@)
	$(POVRAY) $< 2>&1 | grep 'Output file'
	touch $@

ASSEMBLED_DOMINOES_SOURCES := src/dominoes/dominoes.lst $(wildcard src/dominoes/*/*.png)
FILES_DATADIR += data/domino-chain/images/dominoes.png
data/domino-chain/images/dominoes.png: _tmp/dominoes/assembler _tmp/dominoes/povray_done $(ASSEMBLED_DOMINOES_SOURCES)
	@mkdir -p $(dir $@)
	_tmp/dominoes/assembler $@ 58 2 200 src/dominoes/dominoes.lst

FILES_IMAGES_SRC := $(wildcard src/images/*.png)
FILES_DATADIR += $(patsubst src/images/%,data/domino-chain/images/%,$(FILES_IMAGES_SRC))
data/domino-chain/images/%: src/images/%
	@mkdir -p $(dir $@)
	cp $< $@

FILES_SOUNDS_SRC := $(wildcard src/sounds/*.ogg)
FILES_DATADIR += $(patsubst src/sounds/%,data/domino-chain/sounds/%,$(FILES_SOUNDS_SRC))
data/domino-chain/sounds/%: src/sounds/%
	@mkdir -p $(dir $@)
	cp $< $@

FILES_THEMES_SRC := $(wildcard src/themes/*)
FILES_DATADIR += $(patsubst src/themes/%,data/domino-chain/themes/%,$(FILES_THEMES_SRC))
data/domino-chain/themes/%: src/themes/%
	@mkdir -p $(dir $@)
	cp $< $@

FILES_PO := $(wildcard src/po/*.po)
FILES_DATADIR += $(patsubst src/po/%.po,data/locale/%/LC_MESSAGES/domino-chain.mo,$(FILES_PO))
data/locale/%/LC_MESSAGES/domino-chain.mo: src/po/%.po
	@mkdir -p $(dir $@)
	$(MSGFMT) -c -o $@ $<

FILES_DATADIR += data/icons/hicolor/16x16/apps/domino-chain.png
FILES_DATADIR += data/icons/hicolor/32x32/apps/domino-chain.png
FILES_DATADIR += data/icons/hicolor/48x48/apps/domino-chain.png
FILES_DATADIR += data/icons/hicolor/64x64/apps/domino-chain.png
data/icons/hicolor/%/apps/domino-chain.png: src/doc/domino-chain.ico
	@mkdir -p $(dir $@)
	$(CONVERT) +set date:create +set date:modify $<[$(shell expr substr $* 1 2 / 16 - 1)] $@

DOC_INCLUDES += src/doc/upload-url-dist-windows

FILES_DATADIR += data/metainfo/domino-chain.metainfo.xml
data/metainfo/domino-chain.metainfo.xml: src/doc/doc.sh $(DOC_INCLUDES)
	@mkdir -p $(dir $@)
	$< metainfo >$@

FILES_DATADIR += data/applications/domino-chain.desktop
data/applications/domino-chain.desktop: src/doc/doc.sh $(DOC_INCLUDES)
	@mkdir -p $(dir $@)
	$< desktop >$@

FILES_DATADIR += data/doc/domino-chain/html/index.html
data/doc/domino-chain/html/index.html: src/doc/doc.sh $(DOC_INCLUDES)
	@mkdir -p $(dir $@)
	$< html >$@

FILES_DATADIR += data/man/man6/domino-chain.6.gz
data/man/man6/domino-chain.6.gz: src/doc/doc.sh $(DOC_INCLUDES)
	@mkdir -p $(dir $@)
	$< man | gzip -9n >$@

README.md: src/doc/doc.sh $(DOC_INCLUDES)
	@mkdir -p $(dir $@)
	shellcheck -f gcc $<
	$< readme >$@

AUTHORS: src/doc/doc.sh $(DOC_INCLUDES)
	@mkdir -p $(dir $@)
	$< authors >$@

FILES_DATADIR += data/doc/domino-chain/html/assets/style.css
data/doc/domino-chain/html/assets/style.css: src/doc/style.css
	@mkdir -p $(dir $@)
	cp $< $@

FILES_DATADIR += data/doc/domino-chain/html/assets/domino-chain-header.jpg
data/doc/domino-chain/html/assets/domino-chain-header.jpg: src/doc/domino-chain-header.png
	@mkdir -p $(dir $@)
	$(CONVERT) -quality 85 $< $@

FILES_LEVELS_SRCDIRS := $(wildcard src/levels/*)
FILES_DATADIR += $(patsubst src/levels/%,data/domino-chain/levels/%.gz,$(FILES_LEVELS_SRCDIRS))
data/domino-chain/levels/%.gz: src/levels/%/*.level
	@mkdir -p $(dir $@)
	cat src/levels/$*/*.level | gzip -9n >$@

_tmp/po/leveltexts.cpp: src/levels/*/*.level
	@mkdir -p $(dir $@)
	sed -n '/^\(Description\|Hint\|Name\|Tutorial\)$$/,/^[^|]/ s,^| \(.*\)$$,_("\1"),p' src/levels/*/*.level | LC_ALL=C sort -u >$@

FILES_DATADIR_SYS += data/fonts/FreeSans.ttf
data/fonts/FreeSans.ttf:
	@mkdir -p $(dir $@)
	if [ -e /usr/share/fonts/truetype/freefont/FreeSans.ttf ]; then cp /usr/share/fonts/truetype/freefont/$(notdir $@) $@; \
	elif [ -e /usr/share/fonts/FreeSans.ttf ]; then cp /usr/share/fonts/$(notdir $@) $@; \
	elif [ -e /usr/share/fonts/freefont/FreeSans.ttf ]; then cp /usr/share/fonts/freefont/$(notdir $@) $@; \
	else echo 'Unable to find $(notdir $@)'; exit 1; \
	fi

.PHONY: all
all: README.md AUTHORS $(FILES_BINDIR) $(FILES_DATADIR) $(FILES_DATADIR_SYS)

.PHONY: check
check: all
	./domino-chain -c src/recordings/finish/*
	./domino-chain -y src/recordings/fail
	./domino-chain -x src/recordings/crash
	@echo OK

DIST_WINDOWS := Domino-Chain_$(VERSION)_for_Windows.zip
TARGET_WINDOWS = x86_64-w64-mingw32.static
DIST_CLEAN_FILES += $(TARGET_WINDOWS)-domino-chain.exe $(BIN_WINDOWS) $(DIST_WINDOWS)

$(DIST_WINDOWS): $(ALL_SOURCES)
	[ -e _tmp/mxe ] || git clone https://github.com/mxe/mxe.git _tmp/mxe
	cd _tmp/mxe && git pull --ff-only
	$(MAKE) -C _tmp/mxe MXE_TARGETS=$(TARGET_WINDOWS) MXE_PLUGIN_DIRS=plugins/gcc9 boost fribidi lua sdl2_mixer sdl2_ttf
	PATH=$$(pwd)/_tmp/mxe/usr/bin:$$PATH $(MAKE) -j 4 CROSS=$(TARGET_WINDOWS)-
	rm -rf _tmp/$(basename $@)
	mkdir -p _tmp/$(basename $@)
	cp $(TARGET_WINDOWS)-domino-chain.exe _tmp/$(basename $@)/Domino-Chain.exe
	PATH=$$(pwd)/_tmp/mxe/usr/bin:$$PATH $(TARGET_WINDOWS)-strip -s _tmp/$(basename $@)/Domino-Chain.exe
	tar c $(FILES_DATADIR) $(FILES_DATADIR_SYS) | tar x -C _tmp/$(basename $@)
	sed 's,assets/,data/doc/domino-chain/html/assets/,' <_tmp/$(basename $@)/data/doc/domino-chain/html/index.html >_tmp/$(basename $@)/README.html
	rm -f $@
	cd _tmp && zip -r9 ../$@ $(basename $@)
	rm -rf _tmp/$(basename $@)

.PHONY: dist
dist: $(DIST_WINDOWS)

FILES_INSTALL += $(patsubst %,$(DESTDIR)$(BINDIR)/%,$(FILES_BINDIR))
$(DESTDIR)$(BINDIR)/%: %
	$(INSTALL) -m 755 -d $(dir $@)
	$(INSTALL) -m 755 $< $@

FILES_INSTALL += $(patsubst data/%,$(DESTDIR)$(DATADIR)/%,$(FILES_DATADIR))
$(DESTDIR)$(DATADIR)/%: data/%
	$(INSTALL) -m 755 -d $(dir $@)
	$(INSTALL) -m 644 $< $@

.PHONY: install
install: $(FILES_INSTALL)

PUBLIC_SOURCES = $(filter data/doc/domino-chain/html/%,$(FILES_DATADIR))
PUBLIC_FILES = $(patsubst data/doc/domino-chain/html/%,%,$(PUBLIC_SOURCES))

.PHONY: public
public: $(PUBLIC_SOURCES)
	rm -rf $@
	$(INSTALL) -m 755 -d $(patsubst %,$@/%,$(sort $(dir $(PUBLIC_FILES))))
	for PUBLIC_FILE in $(PUBLIC_FILES); do $(INSTALL) -m 644 data/doc/domino-chain/html/$$PUBLIC_FILE public/$$PUBLIC_FILE; done

.PHONY: release
release:
	[ -e gitlab-token ]
	[ "$$(git diff | wc -c)" = 0 ]
	sed 's/~dev$$//' -i src/version
	$(MAKE) -j 4
	$(MAKE) dist
	curl --request POST --header "PRIVATE-TOKEN: $$(cat gitlab-token)" \
	  --form "file=@Domino-Chain_$$(cat src/version)_for_Windows.zip" \
	  https://gitlab.com/api/v4/projects/domino-chain%2Fdomino-chain.gitlab.io/uploads \
	  | sed -n 's/^.*"url": *"\([^"]\+\)".*$$/\1/p' \
	  >src/doc/upload-url-dist-windows
	$(MAKE) -j 4
	git commit -am "Release $$(cat src/version)"
	git tag -sm "$$(cat src/version)" "$$(cat src/version)"
	echo "1.$$(($$(sed 's/^1\.//' src/version)+1))~dev" >src/version.new
	mv src/version.new src/version
	$(MAKE) -j 4
	git commit -am "Set version to $$(cat src/version)"
	git push --tags

.PHONY: clean
clean:
	rm -f domino-chain *-domino-chain *-domino-chain.exe Domino-Chain*.zip _tmp/dominoes/assembler
	rm -rf data/ public/ _tmp/domino-chain/ _tmp/*-domino-chain/
	@echo 'Hint: Refusing to remove rendered dominoes and MXE. To remove everything, please use "make clean-all".'

.PHONY: clean-all
clean-all:
	rm -f domino-chain *-domino-chain *-domino-chain.exe Domino-Chain*.zip
	rm -rf data/ public/ _tmp/

.PHONY: update-po
update-po: _tmp/po/messages.pot
	for PO_FILE in src/po/*.po; do $(MSGMERGE) -Uq --backup=none $$PO_FILE $<; done

_tmp/po/messages.pot: _tmp/po/leveltexts.cpp src/domino-chain/*.cpp
	@mkdir -p $(dir $@)
	$(XGETTEXT) --msgid-bugs-address=$(MSGID_BUGS_ADDRESS) -cTRANSLATORS: -k_ -kN_ -o $@ $^

=== src/doc/Makefile ===
.PHONY: default
default:
	$(MAKE) -C ../..

=== debian/changelog ===
pushover (1.1-6) unstable; urgency=medium

  * Team upload.
  * Fix watch file (Closes: #1089926)

 -- Patrice Duroux <patrice.duroux@gmail.com>  Sat, 14 Dec 2024 17:18:05 +0100

pushover (1.1-5) unstable; urgency=medium

  * Fix FTBFS with GCC-14 (Closes: #1075402)

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1063459)
    + libsdl2-image-dev is used for the build architecture.
    + cross.patch: Distinguish build and host compiler flags.

 -- Alexandre Detiste <tchet@debian.org>  Sat, 03 Aug 2024 16:55:04 +0200

pushover (1.1-4) unstable; urgency=medium

  * Team upload.
  * Drop myself from uploaders
  * Update my name
  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Thu, 18 Jul 2024 16:57:05 +0000

pushover (1.1-3) unstable; urgency=medium

  * source upload to allow migration of NEW packages
  * build with Lua5.4 instead of Lua5.2
  * rename project on Salsa 'pushover' -> 'domino-chain'

 -- Alexandre Detiste <tchet@debian.org>  Sat, 16 Dec 2023 14:25:10 +0100

pushover (1.1-2) unstable; urgency=low

  * rename binary packages as requested by upstream (Closes: #960382)
  * provide an additional transitional package for existing users
  * bump Standards-Version, no further change needed
  * add copyright information for vendored code

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Dec 2023 18:16:15 +0100

pushover (1.1-1) unstable; urgency=low

  * New upstream version 1.1
  * build with SDL2 (Closes: #1038547)
  * switch to debhelper 13
  * remove patch applied upstream
  * always read assests from system datadir (Closes: #996484)
  * define R³: no
  * remove Debian manpage stub, upstream provide a better one

  -> in the very next upload the game will be renamed 'Domino Chain'
     as requested by upstream (#960382)

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + pushover-data: Add Multi-Arch: foreign.

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Dec 2023 00:57:58 +0100

=== debian/control ===
Source: pushover
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Alexandre Detiste <tchet@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
 imagemagick,
 fonts-freefont-ttf,
 povray,
 liblua5.4-dev,
 libfribidi-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libsdl2-image-dev:native,
 libsdl2-mixer-dev,
 libsdl2-ttf-dev,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/games-team/domino-chain
Vcs-Git: https://salsa.debian.org/games-team/domino-chain.git
Homepage: https://domino-chain.gitlab.io/
Rules-Requires-Root: no

Package: domino-chain
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-freefont-ttf
Recommends: domino-chain-music
Breaks: pushover (<< 1.1-2~), pushover-data (<< 1.1-2~)
Replaces: pushover (<< 1.1-2~), pushover-data (<< 1.1-2~)
Description: Fun puzzle game with dominos
 This is a remake of a fun puzzle game originally published by Ocean in 1992.
 In this game you control an ant that can walk along platforms that are
 connected with ladders. On those platforms are dominos that need to fall
 according to some rules.
 .
  - All dominos must fall and none must crash into another
  - One special domino must fall as last domino and that domino triggers
    the exit door to open when you enter the exit door the level has been
    completed
  - You may rearrange as many dominos as you want, except for the trigger.
    You may not place dominos in front of the doors, except for the vanishing
    domino.
  - You may push once to start a chain reaction with the dominos leading to
    the fall of all of them
  - All this has to be done within a time limit (which is normally generous)
  - There are 10 different dominos that behave differently when pushed, some
    fall, some not, some wait a bit before they fall, some raise, some toppler
    until they meet an obstacle
  - There is a help in the game and introductory levels that show how all the
    dominos work

Package: domino-chain-music
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Fun puzzle game with dominos, music files
 This is a remake of a fun puzzle game originally published by Ocean in 1992.
 In this game you control an ant that can walk along platforms that are
 connected with ladders. On those platforms are dominos that need to fall
 according to some rules.
 .
 This package contains the optional background music.

Package: pushover
Architecture: all
Depends: domino-chain, ${misc:Depends}
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	$(MAKE) BINDIR=/usr/games DATADIR=/usr/share/games CXX=$(CXX) CXXFLAGS='$(CPPFLAGS) $(CXXFLAGS) -Wall -Wextra -g -O2 -std=c++17' LDFLAGS='$(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG) PKG_LUA=lua-5.4 CXXFLAGS_NATIVE='$(CPPFLAGS_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -Wall -Wextra -g -O2 -std=c++17' LDFLAGS_NATIVE='$(LDFLAGS_FOR_BUILD)'

override_dh_auto_test:
	echo "checks needs portable_datadir and are disabled"

override_dh_auto_install:
	$(MAKE) install BINDIR=$(CURDIR)/debian/domino-chain/usr/games DATADIR=$(CURDIR)/debian/tmp/usr/share

=== debian/watch ===
version=4
opts=searchmode=plain \
https://gitlab.com/domino-chain/domino-chain.gitlab.io/-/tags \
  archive/[^/]+/domino-chain.gitlab.io@ANY_VERSION@@ARCHIVE_EXT@
